diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java
index 6abb9118f..759b13bf0 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerSimple.java
@@ -67,7 +67,7 @@ public class ContainerSimple
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
         return name;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index dc68f4736..aaf3943fa 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -136,7 +136,7 @@ public class MenuInventoryCreative extends MenuInventory
 				creativeItems.add(new ItemStack(Blocks.blocksList[id]));
 				count++;
 				
-				if (id == Blocks.WOOL.id() || id == Blocks.PLANKS_OAK_PAINTED.id() || id == Blocks.LAMP_IDLE.id() || id == Blocks.FENCE_PLANKS_OAK_PAINTED.id())
+				if (id == Blocks.WOOL.id() || id == Blocks.PLANKS_OAK_PAINTED.id() || id == Blocks.LAMP_IDLE.id() || id == Blocks.LAMP_INVERTED_ACTIVE.id() || id == Blocks.FENCE_PLANKS_OAK_PAINTED.id())
 				{
 					for (int i = 1; i < 16; i++)
 					{
diff --git a/game/core/src/main/resources/lang/en_US/command.lang b/game/core/src/main/resources/lang/en_US/command.lang
index a2eae4fa1..e0db41bea 100644
--- a/game/core/src/main/resources/lang/en_US/command.lang
+++ b/game/core/src/main/resources/lang/en_US/command.lang
@@ -68,6 +68,7 @@ command.commands.achievement.grant.success_single_entity=Granted achievement §5
 command.commands.achievement.grant.all.success_multiple_entities=Granted all achievements to %s entities
 command.commands.achievement.grant.all.success_single_entity=Granted all achievements to %s
 command.commands.seed.success=Seed: §5[%s]§r
+command.commands.seed.copied_to_clipboard=Copied to clipboard!
 command.commands.clear.success_single_item_single_entity=%s item slot cleared
 command.commands.clear.success_multiple_items_single_entity=%s item slots cleared
 command.commands.clear.success_single_item_multiple_entities=%s item slot cleared from %s entities
diff --git a/game/core/src/main/resources/lang/en_US/stats.lang b/game/core/src/main/resources/lang/en_US/stats.lang
index 2ae4118b9..78ae41fe9 100644
--- a/game/core/src/main/resources/lang/en_US/stats.lang
+++ b/game/core/src/main/resources/lang/en_US/stats.lang
@@ -43,47 +43,47 @@ achievement.requires=Requires '%1$s'
 achievement.openInventory=Taking Inventory
 achievement.openInventory.desc=Press '%1$s' to open your inventory.
 achievement.mineWood=Getting Wood
-achievement.mineWood.desc=Attack a tree until a block of wood pops out
+achievement.mineWood.desc=Attack a tree until a block of wood pops out.
 achievement.buildWorkBench=Benchmarking
-achievement.buildWorkBench.desc=Craft a workbench with four blocks of planks
+achievement.buildWorkBench.desc=Craft a workbench with four blocks of planks.
 achievement.buildPickaxe=Time to Mine!
-achievement.buildPickaxe.desc=Use planks and sticks to make a pickaxe
+achievement.buildPickaxe.desc=Use planks and sticks to make a pickaxe.
 achievement.buildFurnace=Hot Topic
-achievement.buildFurnace.desc=Construct a furnace out of eight stone blocks
+achievement.buildFurnace.desc=Construct a furnace out of eight stone blocks.
 achievement.acquireIron=Acquire Hardware
-achievement.acquireIron.desc=Smelt an iron ingot
+achievement.acquireIron.desc=Smelt an iron ingot.
 achievement.buildHoe=Time to Farm!
-achievement.buildHoe.desc=Use planks and sticks to make a hoe
+achievement.buildHoe.desc=Use planks and sticks to make a hoe.
 achievement.makeBread=Bake Bread
-achievement.makeBread.desc=Turn wheat into bread
+achievement.makeBread.desc=Turn wheat into bread.
 achievement.bakeCake=The Lie
 achievement.bakeCake.desc=Wheat, sugar, milk and eggs!
 achievement.buildBetterPickaxe=Getting an Upgrade
-achievement.buildBetterPickaxe.desc=Construct a better pickaxe
+achievement.buildBetterPickaxe.desc=Construct a better pickaxe.
 achievement.cookFish=Delicious Fish
 achievement.cookFish.desc=Catch and cook fish!
-achievement.onARail=On A Rail
-achievement.onARail.desc=Travel by minecart at least 1 km from where you started 
+achievement.onARail=On a Rail
+achievement.onARail.desc=Travel by minecart at least 1km from where you started.
 achievement.buildSword=Time to Strike!
-achievement.buildSword.desc=Use planks and sticks to make a sword
+achievement.buildSword.desc=Use planks and sticks to make a sword.
 achievement.killEnemy=Monster Hunter
-achievement.killEnemy.desc=Attack and destroy a monster
+achievement.killEnemy.desc=Attack and destroy a monster.
 achievement.killCow=Cow Tipper
-achievement.killCow.desc=Harvest some leather
+achievement.killCow.desc=Harvest some leather.
 achievement.flyPig=When Pigs Fly
-achievement.flyPig.desc=Fly a pig off a cliff
+achievement.flyPig.desc=Fly a pig off a cliff.
 achievement.getSensed=Hostile Spotted
-achievement.getSensed.desc=Get detected by a motion sensor
+achievement.getSensed.desc=Get detected by a motion sensor.
 achievement.craftHandCannon=First Person Shooter
-achievement.craftHandCannon.desc=Craft a Hand Cannon
+achievement.craftHandCannon.desc=Craft a Hand Cannon.
 achievement.collectStone=Neapolitan
-achievement.collectStone.desc=Collect every variant of every stone type
+achievement.collectStone.desc=Collect every variant of every stone type.
 achievement.crushBlocks=Icebreaker
-achievement.crushBlocks.desc=Collect ice by crushing it between a block of obsidian
+achievement.crushBlocks.desc=Collect ice by crushing it between a block of obsidian.
 achievement.repairArmor=Armorsmith
-achievement.repairArmor.desc=Repair a piece of chainmail
+achievement.repairArmor.desc=Repair a piece of chainmail.
 achievement.getChainmail=Chained Up
-achievement.getChainmail.desc=Wear a set of fully repaired chainmail armor
+achievement.getChainmail.desc=Wear a set of fully repaired chainmail armor.
 achievement.openGuidebook=Recipe for Success
 achievement.openGuidebook.desc=Press '%1$s' to open the guidebook.
 achievement.caughtEmAll=Caught 'Em All!
@@ -96,27 +96,25 @@ achievement.getDiamonds=Diamonds!
 achievement.getDiamonds.desc=Mine diamond ore to a diamond.
 achievement.allArmorTypes=Master of None
 achievement.allArmorTypes.desc=Wear an armor piece from 4 different sets.
-achievement.allMusicDiscs=Music Collector
+achievement.allMusicDiscs=Record Collector
 achievement.allMusicDiscs.desc=Collect all music discs.
 achievement.tripleHit=Three for One Deal!
 achievement.tripleHit.desc=Hit three mobs with a single golden arrow.
 
-achievement.enterNether=The Inferno
-achievement.enterNether.desc=Enter the Nether
+achievement.enterNether=Hell Bent
+achievement.enterNether.desc=Enter the Nether.
 achievement.swimNether=Frozen Over
 achievement.swimNether.desc=Melt some ice and take a swim.
-achievement.enterOldworld=As Above...
-achievement.enterOldworld.desc=Enter the Old World
-achievement.enterWarrens=...So Below
-achievement.enterWarrens.desc=Enter the Warrens
-achievement.getNethercoal=Fiery Fuel
-achievement.getNethercoal.desc=Mine some nethercoal from the Nether.
-achievement.hitFireball=I can do Better
+achievement.enterWarrens=Hidden Depths
+achievement.enterWarrens.desc=Enter the Warrens.
+achievement.getNethercoal=Hot Stuff
+achievement.getNethercoal.desc=Mine some Nether Coal.
+achievement.hitFireball=Serve!
 achievement.hitFireball.desc=Hit a Ghast's fireball at another mob.
 achievement.sleepNether=Rude Awakening
-achievement.sleepNether.desc=Attempt to sleep in the Nether.
+achievement.sleepNether.desc=Try to sleep in the Nether.
 achievement.lightSign=Glow in the Dark
-achievement.lightSign.desc=Apply glowstone dust to a sign.
+achievement.lightSign.desc=Apply Glowstone Dust to a sign.
 achievement.mostWanted=Most Wanted
 achievement.mostWanted.desc=Have more then 10 Zombie Pigmen attack you.
 achievement.fastTravel=Dimensional Slingshot
diff --git a/game/core/src/main/resources/lang/en_US/strings.lang b/game/core/src/main/resources/lang/en_US/strings.lang
index 5543ac3bb..b5e85bc80 100644
--- a/game/core/src/main/resources/lang/en_US/strings.lang
+++ b/game/core/src/main/resources/lang/en_US/strings.lang
@@ -170,4 +170,16 @@ side.north=North
 side.south=South
 side.west=West
 side.east=East
-side.none=None
\ No newline at end of file
+side.none=None
+
+container.activator.name=Activator
+container.chest.name=Chest
+container.dispenser.name=Dispenser
+container.flag.name=Flag
+container.furnace.name=Furnace
+container.furnace_blast.name=Blast Furnace
+container.trommel.name=Trommel
+container.minecart.name=Minecart
+container.crafting.name=Crafting
+container.inventory.name=Inventory
+container.result.name=Result
\ No newline at end of file
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index cac8ecec3..0bab05841 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -526,7 +526,7 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         getNextWindowId();
         PacketHandlerServer.LOGGER.info("{} interacted with chest at ({}, {}, {})", username, x, y, z);
-        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_GENERIC_CONTAINER, container.getName(), container.getContainerSize()));
+        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_GENERIC_CONTAINER, container.getNameTranslationKey(), container.getContainerSize()));
         craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new MenuContainer(inventory, container);
         craftingInventory.containerId = currentWindowId;
@@ -539,11 +539,11 @@ public class PlayerServer extends Player implements ContainerListener {
         getNextWindowId();
         if (blockEntity instanceof TileEntityFurnaceBlast)
         {
-            playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_BLAST_FURNACE, blockEntity.getName(), blockEntity.getContainerSize()));
+            playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_BLAST_FURNACE, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
         }
         else
         {
-            playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_FURNACE, blockEntity.getName(), blockEntity.getContainerSize()));
+            playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_FURNACE, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
         }
         craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new MenuFurnace(inventory, blockEntity);
@@ -555,7 +555,7 @@ public class PlayerServer extends Player implements ContainerListener {
 	public void displayDispenserScreen(TileEntityDispenser blockEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_DISPENSER, blockEntity.getName(), blockEntity.getContainerSize()));
+        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_DISPENSER, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
         craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new MenuTrap(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
@@ -566,7 +566,7 @@ public class PlayerServer extends Player implements ContainerListener {
     public void displayActivatorScreen(TileEntityActivator blockEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_ACTIVATOR, blockEntity.getName(), blockEntity.getContainerSize()));
+        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_ACTIVATOR, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
         craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new MenuActivator(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
@@ -578,7 +578,7 @@ public class PlayerServer extends Player implements ContainerListener {
 	public void displayTrommelScreen(TileEntityTrommel blockEntity)
     {
         getNextWindowId();
-        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_TROMMEL, blockEntity.getName(), blockEntity.getContainerSize()));
+        playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_TROMMEL, blockEntity.getNameTranslationKey(), blockEntity.getContainerSize()));
         craftingInventory.onCraftGuiClosed(this);
         craftingInventory = new MenuTrommel(inventory, blockEntity);
         craftingInventory.containerId = currentWindowId;
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 1e603783a..6f2b8a8c5 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -1216,6 +1216,20 @@ class WorkbenchGenerator {
                 .create(color.colorID + "_lamp_convert", new ItemStack(Blocks.LAMP_IDLE, 1, color.blockMeta));
         }
 
+        for (DyeColor color : DyeColor.values()) {
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput(Blocks.LAMP_IDLE, color.blockMeta)
+                .addInput(Blocks.TORCH_REDSTONE_ACTIVE)
+                .create(color.colorID + "_lamp_invert", new ItemStack(Blocks.LAMP_INVERTED_ACTIVE, 1, color.blockMeta));
+        }
+
+        for (DyeColor color : DyeColor.values()) {
+            RecipeBuilder.Shapeless(CORE_NAMESPACE)
+                .addInput("minecraft:lamps_inverted")
+                .addInput(new ItemStack(Items.DYE, 1, color.itemMeta))
+                .create(color.colorID + "_lamp_inverted_convert", new ItemStack(Blocks.LAMP_INVERTED_ACTIVE, 1, color.blockMeta));
+        }
+
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "X",
